﻿package  {
	import flash.media.Camera;
	import flash.media.Video;
	import flash.display.*;
	import flash.events.*;
	import flash.geom.*;
	import flash.filters.*;
	import flash.utils.Timer;
	import flash.text.*;
	import flash.system.fscommand;
	
	public class Interactive311 extends MovieClip{
		
		//private var sizeW:int = 1280;
		//private var sizeH:int = 720;
		private var sizeW:int = stage.stageWidth;
		private var sizeH:int = stage.stageHeight;

		public function Interactive311() {
			//Constructor
			fscommand("fullscreen","true");
			stage.scaleMode = StageScaleMode.SHOW_ALL;
			init();
		}
		
		//General Vars
		private var frame:int = 0;
		
		public var video:Video;
		private var grainBitmapData:BitmapData;
		private var bgbm:BitmapData;
		private var canvas:Bitmap;
		private var comparisonFrame:BitmapData;
		private var currentFram:BitmapData;
		private var HFlip:Matrix;
		private var pt:Point;
		private var filter:BlurFilter;
		private var liteBlurFilter:BlurFilter;
		private var ct:ColorTransform;
		private var camera:Camera;
		private var flip:int = 1;
		
		private var filterArea:Rectangle = new Rectangle(0,0,sizeW,sizeH);
		private var blocks:Array;
		private var blurValue:int = 10;
		private var debug:int = 0;
		private var thresh:int = 169;
		private var grain:int = 1;
		private var cammode:int = 0;
		private var threshH:uint = 0xFFDDDDDD;
		
		private var gformat:TextFormat;
		private var cameraRes:TextField;
		
		//Initiate the whole shebang
		private function init(){
			//Camera Instance
			camera = Camera.getCamera();
			//camera.setMode(1280,720,30);
			//camera.setMode(960,544,30);
			camera.setMode(640,360,30);
			
			//Camera Debug Object
			video = new Video(sizeW,sizeH);
			//video.scaleX = 5;
			video.attachCamera(camera);			
			
			bgbm = new BitmapData(sizeW,sizeH,false,0);
			canvas = new Bitmap(bgbm);			
			this.addChild(canvas);
			
			pt = new Point(0,0);
			filter = new BlurFilter(50,50,1);
			
			//"Lite" blur filter used by object detection
			liteBlurFilter = new BlurFilter(blurValue,blurValue,1);
			ct = new ColorTransform(0.2,0.2,0.4,BitmapFilterQuality.MEDIUM);
			
			grainBitmapData = new BitmapData(sizeW,sizeH,true);
			comparisonFrame = new BitmapData(sizeW,sizeH,true,0x01000000);
			currentFram = new BitmapData(sizeW,sizeH,false);
			
			this.addEventListener(Event.ENTER_FRAME, update);
			stage.addEventListener(MouseEvent.CLICK,newBaseFrame);
			stage.addEventListener(KeyboardEvent.KEY_DOWN,keyboard);
			
			/*
			var myTimer:Timer = new Timer(1000);
			myTimer.addEventListener(TimerEvent.TIMER, runMany);
			myTimer.start();
			
			function runMany(event:TimerEvent):void {
				newBaseFrame(null,true);
			}
			
			*/
			HFlip = new Matrix();
			HFlip.scale(-1,1);
			HFlip.translate(video.width,0);
			
			
			cameraRes = new TextField
			gformat = new TextFormat();
			gformat.font = "Emulator"
			gformat.size = 9;
			cameraRes.text = "640x360";
			cameraRes.textColor = 0xFFFFFFFF;
			cameraRes.x = 10;
			cameraRes.y = sizeH-20;
			cameraRes.setTextFormat(gformat);
			cameraRes.antiAliasType = AntiAliasType.ADVANCED;
			stage.addChild(cameraRes);
		}
		
		//Handle keyboard actions
		private function keyboard(event:KeyboardEvent):void{
			trace(event.keyCode);
			var c:int = event.keyCode;
			
			if(c == 107 || c == 187){ //Plus
				blurValue++;
			} else if(c == 109 || c == 189){ //Minus
				if(blurValue>=0) blurValue+=-1;
			
			} else if(c == 68){ //D key (debug)
				debug++;
				if(debug>5) debug = 0;
			
			} else if(c == 221){ //Right SQ Bracket
				if(thresh<255) thresh++;
			} else if(c == 219){ //Left SQ Bracket
				if(thresh>0) thresh+=-1;
			} else if(c == 71){ //G for grain toggle
				grain = grain * -1;
			} else if(c == 67){ //C key (camera mode)
				cammode++;
				if(cammode>2) cammode = 0;

				if(cammode==0){
					camera.setMode(640,360,30);
					cameraRes.text = "640x360";
				} else if(cammode==1){
					camera.setMode(960,544,30);
					cameraRes.text = "960x544";
				} else if(cammode==2){
					camera.setMode(1280,720,30);
					cameraRes.text = "1280x720";
				}
				cameraRes.setTextFormat(gformat);
			} else if(c==70){ //F key for fullscreen
				toggleFullScreen(event)
			} else if(c==72){ //H key for Horizontal flip
				flip = flip * -1;
				
				if(flip<0){
					HFlip.scale(-1,1);
					HFlip.translate(video.width,0);
				} else {
					HFlip.scale(1,1);
					HFlip.translate(0,0);
				}
			}
			
			var s:String = thresh.toString(16);
			threshH = uint("0xFF"+s+s+s);
			liteBlurFilter = new BlurFilter(blurValue,blurValue,1);
		}
		
		function toggleFullScreen(event:KeyboardEvent):void
		{
		  if (this.stage.displayState == StageDisplayState.FULL_SCREEN)
			this.stage.displayState=StageDisplayState.NORMAL;
		  else
			this.stage.displayState=StageDisplayState.FULL_SCREEN;	
		}
		
		//Keep background up to date
		private function newBaseFrame(e:Event, auto:Boolean = false):void{
			var vid:BitmapData = new BitmapData(sizeW,sizeH,false);
			vid.draw(video);
			const rc:Number = 1/3, gc:Number = 1/3, bc:Number = 1/3;
			vid.applyFilter(vid, filterArea, pt, new ColorMatrixFilter([rc, gc, bc, 0, 0,rc, gc, bc, 0, 0, rc, gc, bc, 0, 0, 0, 0, 0, 1, 0]));
			vid.applyFilter(vid, filterArea, pt, liteBlurFilter);
			
			if(auto){
				comparisonFrame.draw(vid,HFlip,new ColorTransform(1,1,1,0.04));
				
				
			} else {
				comparisonFrame.draw(vid,HFlip);
			}
		}
		
		//Called every frame
		private function update(e:Event):void{
			
			bgbm.draw(video,HFlip);
			const rc:Number = 1/3, gc:Number = 1/3, bc:Number = 1/3;
			bgbm.applyFilter(bgbm, filterArea, pt, new ColorMatrixFilter([rc, gc, bc, 0, 0,rc, gc, bc, 0, 0, rc, gc, bc, 0, 0, 0, 0, 0, 1, 0]));
			bgbm.applyFilter(bgbm, filterArea, pt, liteBlurFilter);
			
			bgbm.draw(comparisonFrame,null,null, BlendMode.DIFFERENCE);
			bgbm.colorTransform(filterArea,new ColorTransform(10,10,10));
			
			
			
			bgbm.threshold(bgbm, filterArea, pt, "<", threshH, 0xff000000);
			bgbm.threshold(bgbm, filterArea, pt, ">", threshH, 0xffffffff);
			
			bgbm.applyFilter(bgbm, filterArea, pt, liteBlurFilter);
			
			
			bgbm.draw(getBlocks(bgbm));
			
			//bgbm.draw(getDiffImage(bgbm));
			if(debug==5){
				bgbm.draw(video, HFlip);
			} else if(debug==4){
				bgbm.draw(comparisonFrame);
			} else if(debug<3){
				var vid:BitmapData = new BitmapData(sizeW,sizeH,false);
				vid.draw(video,HFlip);
				vid.applyFilter(vid, filterArea, pt, new ColorMatrixFilter([rc, gc, bc, 0, 0,rc, gc, bc, 0, 0, rc, gc, bc, 0, 0, 0, 0, 0, 1, 0]));
				
				
				if(debug>1)
					bgbm.draw(vid,null,new ColorTransform(1,1,1,0.5));
				else if(debug==0)
					bgbm.draw(vid);
				
				//bgbm.threshold(bgbm, filterArea, pt, ">=", 0xFF808080, 0xFFFFFFFF, 0xFFFFFFFF);
				//bgbm.threshold(bgbm, filterArea, pt, "<=", 0xFF808080, 0xFF000000, 0xFFFFFFFF);
				
				//comparisonFrame.draw(vid,null,new ColorTransform(2,2,2,0.1));
				
				
				//newBaseFrame(null,true);
				
				//bgbm.applyFilter(bgbm, filterArea, pt, filter);
				bgbm.colorTransform(filterArea,ct);
				
				if(debug>0){
					var circle:Sprite = new Sprite();
					for(var i=0;i<blocks.length;i++){
						circle.graphics.beginFill(0xFF0000);
						circle.graphics.drawCircle(blocks[i].rect.x+(blocks[i].rect.width/2), blocks[i].rect.y+(blocks[i].rect.height/2), 3);
						circle.graphics.endFill();
					}
					
					bgbm.draw(circle);
				}
				/*
				if(texts.length>0)
				for(i=0;i<texts.length;i++){
					stage.removeChild(texts[i]);
				}
				texts.splice();
				*/
				for(i=0;i<blocks.length;i++){
					var format:TextFormat = new TextFormat();
					format.font = "Emulator"
					format.size = 12;
					var txt:TextField = new TextField();
					txt.text = "0x"+i.toString(16)+" :: "+ rndstr(5);
					txt.textColor = 0xFFFFFFFF;
					txt.x = blocks[i].rect.x+(blocks[i].rect.width/2)+10;
					txt.y = blocks[i].rect.y+(blocks[i].rect.height/2)-10;
					txt.setTextFormat(format);
					txt.antiAliasType = AntiAliasType.ADVANCED;
					//stage.addChild(txt);
					var matrix:Matrix = new Matrix();
					matrix.translate(txt.x,txt.y);
					bgbm.draw(txt,matrix,new ColorTransform(1,1,1,0.6));
					
				}
				
				if(grain>0){
					grainBitmapData.noise(frame,0,25,7,true);
					bgbm.draw(grainBitmapData,null,null,BlendMode.ADD);
					//var seed:Number = Math.floor(Math.random()*100);
					//grainBitmapData.colorTransform(new Rectangle(0,0,sizeW,sizeH),);			
					frame++;
				}
			}
		}
		
		private function rndstr(len:int):String{
			var chars:Array = ['a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z','A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z','1','2','3','4','5','6','7','8','9','0'];
			var o:String = "";
			for(var i = 0; i<len; i++){
				var num:int = Math.floor( (Math.random()*(chars.length-1)) );
				o+=chars[num];
			}
			return o;
		}
		
		public function getBlocks(s: BitmapData): BitmapData {
		blocks = new Array();
		var i: uint = 0;
		var o: Object;
		var size: uint;
		var r: BitmapData = new BitmapData(s.width, s.height);
		r.draw(s);
		var sp: Sprite = new Sprite();
		var g: Graphics = sp.graphics;
		var rect1: Rectangle, rect2: Rectangle;
		while (true) {
			i++;
			if (i > 1000) {
				break;
			}
			rect1 = r.getColorBoundsRect(0xffffffff, 0xffffffff);
			if (rect1.isEmpty()) {
				break;
			}
	
			var x = rect1.x;
			for (var y: uint = rect1.y;
			y < rect1.y + rect1.height;
			y++) {
				if (r.getPixel32(x, y) == 0xffffffff) {
					r.floodFill(x, y, 0xffff00ff);
					rect2 = r.getColorBoundsRect(0xffffffff, 0xffff00ff);
					size = rect2.width * rect2.height;
					if (size > 300) {
						o = new Object();
						o.size = size;
						o.rect = rect2;
						o.bmpd = new BitmapData(o.rect.width, o.rect.height);
						o.bmpd.copyPixels(r, o.rect, new Point(0, 0));
						blocks.push(o);
					}
					r.floodFill(x, y, 0xff00ffff);
				}
			}
		}
	
		for (i = 0; i < blocks.length; i++) {
			g.lineStyle(0, 0x00FF00);
			g.drawRect(blocks[i].rect.x, blocks[i].rect.y, blocks[i].rect.width, blocks[i].rect.height);
		}
	
		r.draw(sp);
		return r;
	}
	
	public function drawBlobs(s: BitmapData): BitmapData {
		var sp: Sprite = new Sprite();
		var g = sp.graphics;
		var r: BitmapData = new BitmapData(s.width, s.height);
		r.draw(s);
		var pts: Array;
		var b: Object;
		var mid1: Point, mid2: Point;
		var x: int, y: int, i: uint, j: uint;
		for (i = 0; i < blocks.length; i++) {
			pts = [];
			b = blocks[i];
			for (y = 0; y < b.rect.height; y += 5) {
				for (x = 0; x < b.rect.width; x += 1) {
					if (b.bmpd.getPixel(x, y) == 0xff00ff) {
						pts.push(new Point(x, y));
						break;
					}
				}
			}
			for (y = b.rect.height - 1; y >= 0; y -= 5) {
				for (x = b.rect.width - 1; x >= 0; x -= 1) {
					if (b.bmpd.getPixel(x, y) == 0xff00ff) {
						pts.push(new Point(x, y));
						break;
					}
				}
			}
			g.beginFill(0xFF0000, 0.2);
			g.lineStyle(0, 0xFF0000);
			for (j = 0; j < pts.length; j++) {
				if (j == 0) {
					mid1 = Point.interpolate(pts[j], pts[(j + 1) % pts.length], 0.5);
					g.moveTo(b.rect.x + mid1.x, b.rect.y + mid1.y);
				}
				mid2 = Point.interpolate(pts[(j + 2) % pts.length], pts[(j + 1) % pts.length], 0.5);
				g.curveTo(b.rect.x + pts[(j + 1) % pts.length].x, b.rect.y + pts[(j + 1) % pts.length].y, b.rect.x + mid2.x, b.rect.y + mid2.y);
			}
			g.endFill();
		}
		r.draw(sp);
		return r;
	}
		
		public function getDiffImage(s:BitmapData):BitmapData {
			var r:BitmapData = new BitmapData(s.width,s.height);
			var r2:BitmapData = new BitmapData(s.width,s.height);
			var rect:Rectangle = new Rectangle(0,0,s.width,s.height);
			var pt:Point = new Point(0,0);
			r.draw(s);
			r2.draw(s);
			var mtx = new Matrix();
			mtx.translate(-1,0);
			r.draw(s, mtx, new ColorTransform(), BlendMode.DIFFERENCE);
			mtx.translate(2,2);
			r2.draw(s, mtx, new ColorTransform(), BlendMode.DIFFERENCE);
			
			r.copyPixels(r, new Rectangle(2,0,2,s.height), pt);
			r2.copyPixels(r2, new Rectangle(0,2,s.width,2), pt);
			
			r.draw(r2, new Matrix(), new ColorTransform());
			
			var filter:ConvolutionFilter = new ConvolutionFilter(3,3,
			[0.1,0.1,0.1,
			0.1,0.1,0.1,
			0.1,0.1,0.1]);
			r.applyFilter(r,rect,pt,filter);
			r.threshold(r, rect, pt, "<", 0xff111111, 0xff000000);
			r.threshold(r, rect, pt, "!=", 0xff000000, 0xffffffff);
			return r;
		}

	}
	
}
